(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["react-worker-dom"] = factory();
	else
		root["react-worker-dom"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/static/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _nodeType = __webpack_require__(7);

	var _constants = __webpack_require__(2);

	var _bridge = __webpack_require__(8);

	var _bridge2 = _interopRequireDefault(_bridge);

	var _DomElement = __webpack_require__(12);

	var _DomElement2 = _interopRequireDefault(_DomElement);

	var _Fragment = __webpack_require__(16);

	var _Fragment2 = _interopRequireDefault(_Fragment);

	var _TextNode = __webpack_require__(17);

	var _TextNode2 = _interopRequireDefault(_TextNode);

	var _Comment = __webpack_require__(18);

	var _Comment2 = _interopRequireDefault(_Comment);

	var _eventHandler = __webpack_require__(15);

	var _eventHandler2 = _interopRequireDefault(_eventHandler);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var nodes = {};

	var Document = {
	    nodeType: _nodeType.DOCUMENT_NODE,
	    _guid: 'document',
	    nodeName: '#document',
	    documentMode: 12,
	    documentElement: {
	        style: {},
	        textContent: true
	    },
	    oninput: true,
	    onchange: true,
	    createElement: function createElement(tag) {
	        var el = (0, _DomElement2.default)(tag);
	        el.ownerDocument = document;
	        return el;
	    },
	    createComment: function createComment(comment) {
	        return new _Comment2.default(comment);
	    },
	    createDocumentFragment: function createDocumentFragment() {
	        return new _Fragment2.default();
	    },
	    createTextNode: function createTextNode(val) {
	        return new _TextNode2.default(val);
	    },
	    addEventListener: function addEventListener(eventType, callback, useCapture) {
	        _eventHandler2.default.add(this, eventType, callback, useCapture);
	    },
	    createEvent: function createEvent() {
	        // TODO - Implement this
	        console.log('Create event called', arguments);
	        return {};
	    }
	};

	var Window = {
	    addEventListener: function addEventListener(eventType, callback, useCapture) {
	        //EventHandler.add(this, eventType, callback, useCapture);
	    },

	    document: Document,
	    location: self.location
	};

	self.window = Window;
	self.document = Document;
	self.document.body = self.document.createElement('body');
	self.document.head = self.document.createElement('head');
	self.topElement = self.document.createElement('div');
	self.topElement.__TOP = true;

	_bridge2.default.send(_constants.OPS.attachBody, null, [self.document.body._guid, self.document.body]);
	_bridge2.default.send(_constants.OPS.attachHead, null, [self.document.head._guid, self.document.head]);
	_bridge2.default.send(_constants.OPS.attachRoot, null, [self.topElement._guid, self.topElement]);

	exports.default = self.topElement;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _constants = __webpack_require__(2);

	var _TouchList = __webpack_require__(3);

	var _TouchList2 = _interopRequireDefault(_TouchList);

	var _Screen = __webpack_require__(5);

	var _Screen2 = _interopRequireDefault(_Screen);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Channel = function () {
	    function Channel(channel) {
	        _classCallCheck(this, Channel);

	        this.channel = channel;
	    }

	    _createClass(Channel, [{
	        key: 'send',
	        value: function send(type, payload) {
	            this.channel.postMessage(JSON.stringify({ type: type, payload: payload }));
	        }
	    }, {
	        key: 'onMessage',
	        value: function onMessage(handler) {
	            this.channel.addEventListener('message', function (_ref) {
	                var data = _ref.data;

	                var _JSON$parse = JSON.parse(data);

	                var type = _JSON$parse.type;
	                var payload = _JSON$parse.payload;

	                handler(type, payload);
	            });
	        }
	    }], [{
	        key: 'serializeEvent',
	        value: function serializeEvent(e) {
	            var result = {
	                bubbles: e.bubbles,
	                cancelable: e.cancelable,
	                defaultPrevented: e.defaultPrevented,
	                eventPhase: e.eventPhase,
	                isTrusted: e.isTrusted,
	                timeStamp: e.timeStamp,
	                type: e.type,
	                currentTarget: e.currentTarget['__reactNode'],
	                target: e.target['__reactNode'],
	                targetProps: {
	                    value: e.target.value,
	                    checked: e.target.checked,
	                    selected: e.target.selected
	                }
	            };
	            // TODO: Create general event parsing method to handle all even types
	            if (isTouchEvent(e)) {
	                result = Object.assign(result, getTouchProperties(e));
	            }
	            return JSON.stringify(result);
	        }
	    }, {
	        key: 'deserializeEvent',
	        value: function deserializeEvent(msg) {
	            var e = JSON.parse(msg);
	            if (isTouchEvent(e)) {
	                e = Object.assign(e, getTouchProperties(e));
	            }
	            e.preventDefault = e.stopPropgation = function () {};
	            return e;
	        }
	    }]);

	    return Channel;
	}();

	exports.default = Channel;


	function isTouchEvent(e) {
	    return e.type.match(/touchmove|touchstart|touchend|touchcancel/);
	}

	function getTouchProperties(e) {
	    // Support only one touch at the moment
	    var targetTouches = new _TouchList2.default([e.targetTouches[0]]);
	    var touches = new _TouchList2.default([e.touches[0]]);
	    var changedTouches = new _TouchList2.default([e.changedTouches[0]]);
	    var screen = {};
	    if (e.view.screen) {
	        screen = new _Screen2.default(e.view.screen);
	    }

	    return {
	        targetTouches: targetTouches,
	        touches: touches,
	        changedTouches: changedTouches,
	        view: {
	            screen: screen
	        }
	    };
		}

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	// Other constants
	var MAX_QUEUE_SIZE = exports.MAX_QUEUE_SIZE = 500;
	var TIMEOUT = exports.TIMEOUT = 5;

	var WORKER_MESSAGES = exports.WORKER_MESSAGES = {
	    renderTime: 1000,
	    renderQueue: 1001,
	    event: 1002
	};

	var OPS = exports.OPS = {
	    createComment: 0,
	    innerHTML: 1,
	    createDOMElement: 2,
	    setAttribute: 3,
	    createFragment: 4,
	    createTextNode: 5,
	    insertBefore: 6,
	    appendChild: 7,
	    attachRoot: 8,
	    setTextContent: 9,
	    addEventHandler: 10,
	    removeEventHandler: 11,
	    setStyle: 12,
	    attachHead: 13,
	    replaceChild: 14,
	    attachBody: 15
		};

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _Touch = __webpack_require__(4);

	var _Touch2 = _interopRequireDefault(_Touch);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var TouchList = function () {
	    function TouchList(touches) {
	        var _this = this;

	        _classCallCheck(this, TouchList);

	        touches.forEach(function (touch, index) {
	            var touchMock = new _Touch2.default(touch);
	            _this[index] = touchMock;
	        });
	    }

	    _createClass(TouchList, [{
	        key: 'item',
	        value: function item(index) {
	            return this[index];
	        }
	    }, {
	        key: 'length',
	        get: function get() {
	            var hasMoreTouches = true;
	            var index = 0;
	            while (hasMoreTouches) {
	                if (this[index]) {
	                    index += 1;
	                } else {
	                    hasMoreTouches = false;
	                }
	            }
	            return index;
	        }
	    }]);

	    return TouchList;
	}();

		exports.default = TouchList;

/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Touch = function Touch(touch) {
	  _classCallCheck(this, Touch);

	  if (touch) {
	    this.clientX = touch.clientX;
	    this.clientY = touch.clientY;
	    this.identifier = touch.identifier;
	    this.pageX = touch.pageX;
	    this.pageY = touch.pageY;
	    this.screenX = touch.screenX;
	    this.screenY = touch.screenY;
	  }
	};

		exports.default = Touch;

/***/ },
/* 5 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Screen = function Screen(screen) {
	  _classCallCheck(this, Screen);

	  this.availHeight = screen.availHeight;
	  this.availLeft = screen.availLeft;
	  this.availTop = screen.availTop;
	  this.availWidth = screen.availWidth;
	  this.colorDepth = screen.colorDepth;
	  this.height = screen.height;
	  this.orientation = {
	    angle: screen.orientation.angle,
	    onchange: screen.orientation.onchange,
	    type: screen.orientation.type
	  };
	  this.width = screen.width;
	};

		exports.default = Screen;

/***/ },
/* 6 */,
/* 7 */
/***/ function(module, exports) {

	"use strict";

	module.exports = {
	    ELEMENT_NODE: 1,
	    ATTRIBUTE_NODE: 2, // historical
	    TEXT_NODE: 3,
	    CDATA_SECTION_NODE: 4, // historical
	    ENTITY_REFERENCE_NODE: 5, // historical
	    ENTITY_NODE: 6, // historical
	    PROCESSING_INSTRUCTION_NODE: 7,
	    COMMENT_NODE: 8,
	    DOCUMENT_NODE: 9,
	    DOCUMENT_TYPE_NODE: 10,
	    DOCUMENT_FRAGMENT_NODE: 11,
	    NOTATION_NODE: 12 // historical
		};

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _channel = __webpack_require__(1);

	var _channel2 = _interopRequireDefault(_channel);

	var _constants = __webpack_require__(2);

	var _TreeNode = __webpack_require__(9);

	var _TreeNode2 = _interopRequireDefault(_TreeNode);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var WorkerBridge = function () {
	    function WorkerBridge() {
	        _classCallCheck(this, WorkerBridge);

	        this.queue = [];
	        this.channel = new _channel2.default(self);
	        this.channel.onMessage(this.handleMessage.bind(this));
	        this.pollQueue();
	    }

	    _createClass(WorkerBridge, [{
	        key: 'pollQueue',
	        value: function pollQueue() {
	            var _this = this;

	            self.setTimeout(function () {
	                _this.flushQueue();
	                _this.pollQueue();
	            }, _constants.TIMEOUT);
	        }
	    }, {
	        key: 'handleMessage',
	        value: function handleMessage(type, payload) {
	            switch (type) {
	                case _constants.WORKER_MESSAGES.renderTime:
	                    this.rate = payload.count / payload.time;
	                    break;
	                case _constants.WORKER_MESSAGES.event:
	                    this.eventHandler(payload);
	                    break;
	                default:
	                    console.log('Unknown operation %s', type);
	            }
	        }
	    }, {
	        key: 'onEventHandler',
	        value: function onEventHandler(handler) {
	            this.eventHandler = handler;
	        }
	    }, {
	        key: 'send',
	        value: function send(operation, guid, params) {
	            if (!Array.isArray(params)) {
	                params = [params];
	            };
	            var guidPos = [];
	            var args = params.map(function (a, i) {
	                return a instanceof _TreeNode2.default ? (guidPos.push(i), a._guid) : a;
	            });
	            this.queue.push({
	                operation: operation,
	                guid: guid,
	                args: args,
	                guidPos: guidPos.length > 0 ? guidPos : undefined
	            });
	        }
	    }, {
	        key: 'flushQueue',
	        value: function flushQueue() {
	            if (this.queue.length === 0) {
	                return;
	            }
	            this.channel.send(_constants.WORKER_MESSAGES.renderQueue, this.queue);
	            this.queue = [];
	        }
	    }]);

	    return WorkerBridge;
	}();

		exports.default = new WorkerBridge();

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _guid = __webpack_require__(10);

	var _guid2 = _interopRequireDefault(_guid);

	var _constants = __webpack_require__(2);

	var _bridge = __webpack_require__(8);

	var _bridge2 = _interopRequireDefault(_bridge);

	var _nodeList = __webpack_require__(11);

	var _nodeList2 = _interopRequireDefault(_nodeList);

	var _nodeType = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var TreeNode = function () {
	    function TreeNode() {
	        _classCallCheck(this, TreeNode);

	        this.parentNode = null;
	        this._guid = (0, _guid2.default)();
	        this.children = [];
	        this._bridge = _bridge2.default;
	        _nodeList2.default.set(this._guid, this);
	    }

	    _createClass(TreeNode, [{
	        key: 'appendChild',
	        value: function appendChild(node) {
	            this.insertBefore(node, null);
	        }
	    }, {
	        key: 'insertBefore',
	        value: function insertBefore(node, ref) {
	            var _children,
	                _this = this;

	            var insertIndex = this.children.indexOf(ref);
	            var nodesToInsert = [node];

	            if (node.nodeType === _nodeType.DOCUMENT_FRAGMENT_NODE) {
	                nodesToInsert = node.children;
	                node.children = [];
	            }

	            (_children = this.children).splice.apply(_children, [insertIndex < 0 ? this.children.length : insertIndex, 0].concat(_toConsumableArray(nodesToInsert)));
	            nodesToInsert.forEach(function (node) {
	                node.parentNode = _this;
	            });
	            this._bridge.send(_constants.OPS.insertBefore, this._guid, [node, ref]);
	        }
	    }, {
	        key: 'removeChild',
	        value: function removeChild(node) {
	            var childIndex = this.children.indexOf(node);
	            if (childIndex >= 0) {
	                this.children.splice(childIndex, 1);
	                this._bridge.send(_constants.OPS.removeChild, this._guid, [node]);
	            }
	        }
	    }, {
	        key: 'replaceChild',
	        value: function replaceChild(newNode, node) {
	            var index = this.children.indexOf(node);
	            newNode.parentNode = this;
	            this.children[index] = newNode;
	            this._bridge.send(_constants.OPS.replaceChild, this._guid, [newNode, node]);
	        }
	    }, {
	        key: 'firstChild',
	        get: function get() {
	            return this.children[0];
	        }
	    }, {
	        key: 'lastChild',
	        get: function get() {
	            return this.children[this.children.length - 1];
	        }
	    }, {
	        key: 'nextSibling',
	        get: function get() {
	            if (!this.parentNode) {
	                throw 'No parent node, so cannot have siblings';
	            }
	            var children = this.parentNode.children;
	            return children[children.indexOf(this) + 1];
	        }
	    }, {
	        key: 'innerHTML',
	        set: function set(val) {
	            this._innerHTML = val;
	            this._bridge.send(_constants.OPS.innerHTML, this._guid, [val]);
	        },
	        get: function get() {
	            return this._innerHTML;
	        }
	    }]);

	    return TreeNode;
	}();

		exports.default = TreeNode;

/***/ },
/* 10 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	exports.default = function () {
	    return counter++;
	};

		var counter = 0;

/***/ },
/* 11 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var NodeList = function () {
	    function NodeList() {
	        _classCallCheck(this, NodeList);

	        this.nodes = {};
	    }

	    _createClass(NodeList, [{
	        key: "set",
	        value: function set(guid, node) {
	            this.nodes[guid] = node;
	        }
	    }, {
	        key: "get",
	        value: function get(guid) {
	            return this.nodes[guid];
	        }
	    }]);

	    return NodeList;
	}();

		exports.default = new NodeList();

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _TreeNode2 = __webpack_require__(9);

	var _TreeNode3 = _interopRequireDefault(_TreeNode2);

	var _Style = __webpack_require__(13);

	var _Style2 = _interopRequireDefault(_Style);

	var _ClassList = __webpack_require__(14);

	var _ClassList2 = _interopRequireDefault(_ClassList);

	var _constants = __webpack_require__(2);

	var _nodeType = __webpack_require__(7);

	var _eventHandler = __webpack_require__(15);

	var _eventHandler2 = _interopRequireDefault(_eventHandler);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var DomElement = function (_TreeNode) {
	    _inherits(DomElement, _TreeNode);

	    function DomElement(type) {
	        _classCallCheck(this, DomElement);

	        var _this = _possibleConstructorReturn(this, (DomElement.__proto__ || Object.getPrototypeOf(DomElement)).call(this));

	        _this.nodeType = _nodeType.ELEMENT_NODE;
	        _this.nodeName = type;
	        _this.attributes = {};
	        _this._bridge.send(_constants.OPS.createDOMElement, _this._guid, [type]);

	        _this.style = (0, _Style2.default)(function (key, val) {
	            return _this._bridge.send(_constants.OPS.setStyle, _this._guid, [key, val]);
	        });
	        _this.classList = new _ClassList2.default(_this);

	        inputAttributes.forEach(function (prop) {
	            Object;
	        });
	        return _this;
	    }

	    _createClass(DomElement, [{
	        key: 'setAttribute',
	        value: function setAttribute(key, value) {
	            this.attributes[key] = value;
	            this._bridge.send(_constants.OPS.setAttribute, this._guid, [key, value]);
	        }
	    }, {
	        key: 'addEventListener',
	        value: function addEventListener(eventType, callback, useCapture) {
	            _eventHandler2.default.add(this, eventType, callback, useCapture);
	        }
	    }, {
	        key: 'removeEventListener',
	        value: function removeEventListener(eventType, callback, useCapture) {
	            // console.log('// TODO Remove event listener')
	        }
	    }, {
	        key: 'textContent',
	        set: function set(val) {
	            this._textContent = val;
	            this._bridge.send(_constants.OPS.setTextContent, this._guid, [val]);
	        },
	        get: function get() {
	            return this._textContent;
	        }
	    }, {
	        key: 'className',
	        set: function set(value) {
	            this.setAttribute('className', value);
	        },
	        get: function get() {
	            return this.attributes['className'];
	        }
	    }]);

	    return DomElement;
	}(_TreeNode3.default);

	var inputAttributes = ["accept", "align", "alt", "autocomplete ", "autofocus ", "checked", "disabled", "form", "formaction ", "formenctype", "formmethod ", "formnovalidate ", "formtarget ", "height ", "list ", "max ", "maxlength", "min ", "multiple ", "name", "pattern ", "placeholder", "readonly", "required ", "size", "src", "step", "type", "value", "width"];

	exports.default = function (tag) {
	    var element = new DomElement(tag);
	    var props = {};
	    inputAttributes.forEach(function (prop) {
	        return props[prop] = {
	            set: function set(val) {
	                this.setAttribute(prop, val);
	            },
	            get: function get() {
	                return this.attributes[prop];
	            }
	        };
	    });
	    Object.defineProperties(element, props);
	    return element;
	};

/***/ },
/* 13 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var styles = ["alignContent", "alignItems", "alignSelf", "animation", "animationDelay", "animationDirection", "animationDuration", "animationFillMode", "animationIterationCount", "animationName", "animationTimingFunction", "animationPlayState", "background", "backgroundAttachment", "backgroundColor", "backgroundImage", "backgroundPosition", "backgroundRepeat", "backgroundClip", "backgroundOrigin", "backgroundSize", "backfaceVisibility", "border", "borderBottom", "borderBottomColor", "borderBottomLeftRadius", "borderBottomRightRadius", "borderBottomStyle", "borderBottomWidth", "borderCollapse", "borderColor", "borderImage", "borderImageOutset", "borderImageRepeat", "borderImageSlice", "borderImageSource", "borderImageWidth", "borderLeft", "borderLeftColor", "borderLeftStyle", "borderLeftWidth", "borderRadius", "borderRight", "borderRightColor", "borderRightStyle", "borderRightWidth", "borderSpacing", "borderStyle", "borderTop", "borderTopColor", "borderTopLeftRadius", "borderTopRightRadius", "borderTopStyle", "borderTopWidth", "borderWidth", "bottom", "boxDecorationBreak", "boxShadow", "boxSizing", "captionSide", "clear", "clip", "color", "columnCount", "columnFill", "columnGap", "columnRule", "columnRuleColor", "columnRuleStyle", "columnRuleWidth", "columns", "columnSpan", "columnWidth", "content", "counterIncrement", "counterReset", "cursor", "direction", "display", "emptyCells", "filter", "flex", "flexBasis", "flexDirection", "flexFlow", "flexGrow", "flexShrink", "flexWrap", "cssFloat", "font", "fontFamily", "fontSize", "fontStyle", "fontVariant", "fontWeight", "fontSizeAdjust", "fontStretch", "hangingPunctuation", "height", "hyphens", "icon", "imageOrientation", "justifyContent", "left", "letterSpacing", "lineHeight", "listStyle", "listStyleImage", "listStylePosition", "listStyleType", "margin", "marginBottom", "marginLeft", "marginRight", "marginTop", "maxHeight", "maxWidth", "minHeight", "minWidth", "navDown", "navIndex", "navLeft", "navRight", "navUp", "opacity", "order", "orphans", "outline", "outlineColor", "outlineOffset", "outlineStyle", "outlineWidth", "overflow", "overflowX", "overflowY", "padding", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "pageBreakAfter", "pageBreakBefore", "pageBreakInside", "perspective", "perspectiveOrigin", "position", "quotes", "resize", "right", "tableLayout", "tabSize", "textAlign", "textAlignLast", "textDecoration", "textDecorationColor", "textDecorationLine", "textDecorationStyle", "textIndent", "textJustify", "textOverflow", "textShadow", "textTransform", "top", "transform", "transformOrigin", "transformStyle", "transition", "transitionProperty", "transitionDuration", "transitionTimingFunction", "transitionDelay", "unicodeBidi", "verticalAlign", "visibility", "whiteSpace", "width", "wordBreak", "wordSpacing", "wordWrap", "widows", "zIndex"];

	var Style = function Style(onSetStyle) {
	    _classCallCheck(this, Style);

	    this._styles = [];
	    this._onSetStyle = onSetStyle;
	};

	exports.default = function (onSetStyle) {
	    var style = new Style(onSetStyle);
	    var props = {};
	    styles.forEach(function (prop) {
	        return props[prop] = {
	            set: function set(val) {
	                this._styles[prop] = val;
	                this._onSetStyle(prop, val);
	            },
	            get: function get(prop) {
	                return this._styles[prop];
	            }
	        };
	    });
	    Object.defineProperties(style, props);
	    return style;
	};

/***/ },
/* 14 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ClassList = function () {
	    function ClassList(domElement) {
	        _classCallCheck(this, ClassList);

	        this._domElement = domElement;
	    }

	    _createClass(ClassList, [{
	        key: 'add',
	        value: function add(value) {
	            var classList = this._getCurrentClassList();
	            var newClassNames = typeof value === 'string' ? [value] : value;
	            classList.push.apply(classList, _toConsumableArray(newClassNames));
	            this._domElement.setAttribute('className', classList.join(' '));
	        }
	    }, {
	        key: 'remove',
	        value: function remove(value) {
	            var classList = this._getCurrentClassList();
	            var classNames = typeof value === 'string' ? [value] : value;
	            classNames.forEach(function (className) {
	                var index = classList.indexOf(value);
	                if (index >= 0) {
	                    classList.splice(index, 1);
	                }
	            });
	            this._domElement.setAttribute('className', classList.join(' '));
	        }
	    }, {
	        key: 'item',
	        value: function item(index) {
	            var classList = this._getCurrentClassList();
	            return classList[index];
	        }
	    }, {
	        key: 'contains',
	        value: function contains(value) {
	            var classList = this._getCurrentClassList();
	            return classList.includes(value);
	        }
	    }, {
	        key: 'toggle',
	        value: function toggle(value) {
	            console.log('TODO: Implement classList.toggle()');
	        }
	    }, {
	        key: '_getCurrentClassList',
	        value: function _getCurrentClassList() {
	            if (this._domElement.attributes['className']) {
	                return this._domElement.attributes['className'].split(' ');
	            }
	            return [];
	        }
	    }]);

	    return ClassList;
	}();

		exports.default = ClassList;

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _constants = __webpack_require__(2);

	var _bridge = __webpack_require__(8);

	var _bridge2 = _interopRequireDefault(_bridge);

	var _channel = __webpack_require__(1);

	var _channel2 = _interopRequireDefault(_channel);

	var _nodeList = __webpack_require__(11);

	var _nodeList2 = _interopRequireDefault(_nodeList);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var eventHandlerGuid = 0;

	var EventHandler = function () {
	    function EventHandler() {
	        _classCallCheck(this, EventHandler);

	        this.eventHandlers = {};
	        _bridge2.default.onEventHandler(this.onEventHandler.bind(this));
	    }

	    _createClass(EventHandler, [{
	        key: 'add',
	        value: function add(node, type, handler, useCapture) {
	            this.eventHandlers[eventHandlerGuid] = handler;
	            _bridge2.default.send(_constants.OPS.addEventHandler, node._guid, [type, eventHandlerGuid, useCapture]);
	            eventHandlerGuid++;
	        }
	    }, {
	        key: 'remove',
	        value: function remove(node, type, handler) {
	            // TODO - Implement this
	        }
	    }, {
	        key: 'onEventHandler',
	        value: function onEventHandler(_ref) {
	            var handler = _ref.handler;
	            var event = _ref.event;

	            if (typeof this.eventHandlers[handler] === 'function') {
	                var e = _channel2.default.deserializeEvent(event);
	                e.currentTarget = _nodeList2.default.get(e.currentTarget);
	                e.target = _extends({}, _nodeList2.default.get(e.target), e.targetProps);
	                this.eventHandlers[handler](e);
	            } else {
	                console.log(handler, event);
	            }
	        }
	    }]);

	    return EventHandler;
	}();

		exports.default = new EventHandler();

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _TreeNode2 = __webpack_require__(9);

	var _TreeNode3 = _interopRequireDefault(_TreeNode2);

	var _constants = __webpack_require__(2);

	var _nodeType = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Fragment = function (_TreeNode) {
	    _inherits(Fragment, _TreeNode);

	    function Fragment() {
	        _classCallCheck(this, Fragment);

	        var _this = _possibleConstructorReturn(this, (Fragment.__proto__ || Object.getPrototypeOf(Fragment)).call(this));

	        _this.nodeType = _nodeType.DOCUMENT_FRAGMENT_NODE;
	        _this._bridge.send(_constants.OPS.createFragment, _this._guid, []);
	        return _this;
	    }

	    return Fragment;
	}(_TreeNode3.default);

		exports.default = Fragment;

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _TreeNode2 = __webpack_require__(9);

	var _TreeNode3 = _interopRequireDefault(_TreeNode2);

	var _constants = __webpack_require__(2);

	var _nodeType = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var TextNode = function (_TreeNode) {
	    _inherits(TextNode, _TreeNode);

	    function TextNode(val) {
	        _classCallCheck(this, TextNode);

	        var _this = _possibleConstructorReturn(this, (TextNode.__proto__ || Object.getPrototypeOf(TextNode)).call(this));

	        _this.nodeType = _nodeType.TEXT_NODE;
	        _this._bridge.send(_constants.OPS.createTextNode, _this._guid, [val]);
	        _this._textContent = val;
	        return _this;
	    }

	    _createClass(TextNode, [{
	        key: 'textContent',
	        set: function set(val) {
	            this._textContent = val;
	            this._bridge.send(_constants.OPS.setTextContent, this._guid, [val]);
	        },
	        get: function get() {
	            return this._textContent;
	        }
	    }]);

	    return TextNode;
	}(_TreeNode3.default);

		exports.default = TextNode;

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = undefined;

	var _TreeNode2 = __webpack_require__(9);

	var _TreeNode3 = _interopRequireDefault(_TreeNode2);

	var _constants = __webpack_require__(2);

	var _nodeType = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Comment = function (_TreeNode) {
	    _inherits(Comment, _TreeNode);

	    function Comment(val) {
	        _classCallCheck(this, Comment);

	        var _this = _possibleConstructorReturn(this, (Comment.__proto__ || Object.getPrototypeOf(Comment)).call(this));

	        _this.nodeType = _nodeType.COMMENT_NODE;
	        _this.comment = val;
	        _this._bridge.send(_constants.OPS.createComment, _this._guid, [val]);
	        return _this;
	    }

	    return Comment;
	}(_TreeNode3.default);

		exports.default = Comment;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=worker.js.map